import*as React from'react';import {useState,useEffect}from'react';import {useFela}from'react-fela';import {Menu,Input,Checkbox,Dropdown,Badge}from'antd';import {DownOutlined,CaretDownOutlined}from'@ant-design/icons';import {useGetOrganizationMembersQuery}from'@adminide-stack/account-api-client';import {styles}from'./styles.js';import {FilterName}from'../ReportFilter.js';var Status;
(function (Status) {
    Status["ACTIVE"] = "Active";
    Status["INACTIVE"] = "Inactive";
    Status["ACTIVE_INACTIVE"] = "Active & Inactive";
})(Status || (Status = {}));
const TeamDropdown = (props) => {
    const { title, filteredData, setFilteredData } = props;
    const [visible, setVisible] = useState(false);
    const [show, setShow] = useState(false);
    const [checkedList, setCheckedList] = React.useState([]);
    const [checkAll, setCheckAll] = React.useState(false);
    const [status, setStatus] = useState(Status.ACTIVE);
    const [filteredUsers, setFilteredUsers] = useState([]);
    const [count, setCount] = useState(0);
    const { css } = useFela();
    const { data: { getOrganizationMembers: users } = {} } = useGetOrganizationMembersQuery();
    useEffect(() => {
        if (users === null || users === void 0 ? void 0 : users.length) {
            setFilteredUsers(users);
        }
    }, [users]);
    const handleVisibleChange = (value) => {
        if (!value) {
            setCount(checkedList.length);
            setFilteredData(Object.assign(Object.assign({}, filteredData), { [FilterName.TEAM]: {
                    selectedIds: [...checkedList]
                } }));
        }
        setVisible(value);
    };
    const showStatus = () => {
        setShow(!show);
    };
    const onClickStatus = ({ key }) => {
        setStatus(key);
        setShow(false);
    };
    const onChange = list => {
        setCheckedList(list);
        setCheckAll(list.length === users.length);
    };
    const onCheckAllChange = e => {
        setCheckedList(e.target.checked ? users === null || users === void 0 ? void 0 : users.map(user => user.userId) : []);
        setCheckAll(e.target.checked);
    };
    const onChangeInput = (e) => {
        let newUsers = [];
        if (e.target.value.trim()) {
            newUsers = filterUsers(e.target.value);
        }
        else {
            newUsers = users;
        }
        setFilteredUsers(newUsers);
    };
    const filterUsers = (str) => {
        return users === null || users === void 0 ? void 0 : users.filter((user) => {
            return user.name.toLowerCase().includes(str.toLowerCase());
        });
    };
    const content = (React.createElement(Menu, { className: css(styles.menu) },
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement(Input, { onChange: onChangeInput, placeholder: 'Find member...' })),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement("div", { style: { display: 'flex' } },
                React.createElement("div", { className: css(styles.label) }, "SHOW"),
                React.createElement("div", { style: { marginLeft: 'auto' }, onClick: showStatus },
                    React.createElement("a", null, status),
                    React.createElement(DownOutlined, { className: css(styles.icon) })))),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        show ? (React.createElement(React.Fragment, null,
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE_INACTIVE, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE_INACTIVE)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.INACTIVE, onClick: onClickStatus },
                React.createElement("div", null, Status.INACTIVE)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }))) : null,
        filteredUsers.length ? (React.createElement(React.Fragment, null,
            React.createElement(Menu.Item, { className: css(styles.item) },
                React.createElement(Checkbox, { className: css(styles.checkbox), onChange: onCheckAllChange, checked: checkAll }, "Select all")),
            React.createElement(Menu.Divider, { className: css(styles.divider, styles.space) }),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { disabled: true, className: css(styles.item) },
                React.createElement("div", { className: css(styles.label) }, "USERS")),
            React.createElement(Menu.Item, { className: css(styles.disabledItem) },
                React.createElement(Checkbox.Group, { className: css(styles.checkboxGroup), onChange: onChange, value: checkedList },
                    React.createElement(Menu, null, filteredUsers === null || filteredUsers === void 0 ? void 0 : filteredUsers.map((user) => (React.createElement(Menu.Item, { key: user.userId, className: css(styles.item, styles.mTB0) },
                        React.createElement(Checkbox, { value: user.userId, className: css(styles.checkbox) }, user.name))))))))) : (React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement("div", null, "No team")))));
    return (React.createElement(Dropdown, { overlay: content, trigger: ['click'], placement: "bottomLeft", visible: visible, onVisibleChange: handleVisibleChange },
        React.createElement(Badge, { count: count, style: { background: '#2a90fe' } },
            React.createElement("div", { className: css(styles.flex, styles.m5) },
                React.createElement("div", { className: css(styles.capitalize) }, title),
                React.createElement(CaretDownOutlined, { className: css(styles.m4) })))));
};export{TeamDropdown};//# sourceMappingURL=TeamDropdown.js.map
