import*as React from'react';import {useState,useEffect,useCallback,useMemo}from'react';import moment from'moment';import {useGetOrganizationMembersQuery,useGetUserAccountQuery}from'@adminide-stack/account-api-client';import {useSetting}from'@adminide-stack/platform-browser/lib/components';import {useFirstWeekDay}from'../timetracker/hooks/index.js';import {useGetDurationTimeRecordsQuery,useGetProjectsQuery}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import {Reports}from'./ReportComponent.js';import {ReportFilter}from'./ReportFilter.js';const GetDurationTimeRecordsByUserIdQuery = ({ range, userId, recordsByUserId, setRecordsByUserId }) => {
    const [records, setRecords] = useState({});
    const { data, loading, refetch } = useGetDurationTimeRecordsQuery({
        variables: {
            startTime: range.start,
            endTime: range.end,
            userId: userId,
        },
    });
    const { data: { getUserAccount } = {} } = useGetUserAccountQuery({
        variables: { userId },
        skip: !userId,
    });
    const { data: billRateConfig } = useSetting({
        configKey: 'timetracker.user.payment.billRate',
        overrides: { overrideIdentifier: getUserAccount === null || getUserAccount === void 0 ? void 0 : getUserAccount.username },
    });
    const { data: payRateConfig } = useSetting({
        configKey: 'timetracker.user.payment.payRate',
        overrides: { overrideIdentifier: getUserAccount === null || getUserAccount === void 0 ? void 0 : getUserAccount.username },
    });
    const billRate = billRateConfig === null || billRateConfig === void 0 ? void 0 : billRateConfig.resolveConfiguration;
    const payRate = payRateConfig === null || payRateConfig === void 0 ? void 0 : payRateConfig.resolveConfiguration;
    useEffect(() => {
        refetch();
    }, [range, userId]);
    useEffect(() => {
        if (data && !loading) {
            setRecords({ data: data.getDurationTimeRecords });
        }
    }, [data, userId, range, loading]);
    useEffect(() => {
        if (records === null || records === void 0 ? void 0 : records.data) {
            setRecords(Object.assign(Object.assign({}, records), { payRate, billRate }));
            setRecordsByUserId(Object.assign(Object.assign({}, recordsByUserId), { [userId]: Object.assign(Object.assign({}, records), { payRate, billRate }) }));
        }
    }, [payRate, billRate, records === null || records === void 0 ? void 0 : records.data]);
    return null;
};
const Report = () => {
    const [recordsByUserId, setRecordsByUserId] = useState({});
    const [records, setRecords] = useState([]);
    const [filteredRecords, setFilteredRecords] = useState([]);
    const [projects, setProjects] = useState([]);
    const [filteredProjects, setFilteredProjects] = useState([]);
    const [range, setRange] = useState({ start: moment().startOf('week'), end: moment().endOf('week') });
    const { data: { getOrganizationMembers: orgMembers } = {} } = useGetOrganizationMembersQuery();
    const { data, loading, refetch } = useGetDurationTimeRecordsQuery({
        variables: {
            startTime: range.start,
            endTime: range.end,
        },
    });
    const { data: projectsData, loading: loadingProjects } = useGetProjectsQuery();
    const { updateConfiguration } = useSetting({
        configKey: 'timetracker.report.timeRoundingInReports',
    });
    const { value: dowValue } = useFirstWeekDay();
    useEffect(() => {
        setRange({
            start: moment().startOf('week'),
            end: moment().endOf('week'),
        });
    }, []);
    useEffect(() => {
        refetch();
    }, [range]);
    useEffect(() => {
        moment.locale('en', {
            week: { dow: dowValue },
        });
        setRange({
            start: moment().startOf('week'),
            end: moment().endOf('week'),
        });
    }, [dowValue]);
    const getRecords = useCallback(() => (loading || !!!data ? [] : data.getDurationTimeRecords), [loading, data]);
    const getProjects = useCallback(() => (loadingProjects || !!!projectsData ? [] : projectsData.getProjects), [loadingProjects, projectsData]);
    useEffect(() => {
        if (data) {
            setRecords(getRecords());
            setFilteredRecords(getRecords());
        }
    }, [data]);
    useEffect(() => {
        if (projectsData) {
            setProjects(getProjects());
            setFilteredProjects(getProjects());
        }
    }, [projectsData]);
    return useMemo(() => (React.createElement(React.Fragment, null, orgMembers === null || orgMembers === void 0 ? void 0 :
        orgMembers.map((member, index) => {
            return (React.createElement(GetDurationTimeRecordsByUserIdQuery, { key: index, range: range, userId: member.userId, recordsByUserId: recordsByUserId, setRecordsByUserId: setRecordsByUserId }));
        }),
        React.createElement(ReportFilter, { projects: projects, setFilteredProjects: setFilteredProjects, records: records, setFilteredRecords: setFilteredRecords }),
        React.createElement(Reports, { range: range, users: orgMembers, projects: filteredProjects, records: filteredRecords, setRange: setRange, updateConfiguration: updateConfiguration, recordsByUserId: recordsByUserId }))), [range, projects, filteredProjects, records, filteredRecords, recordsByUserId, orgMembers]);
};export default Report;//# sourceMappingURL=index.js.map
