import React__default,{useState}from'react';import HeaderTimerHandler from'../HeaderTimerHandler/index.js';import {useDispatch,useSelector}from'react-redux';import {currentTimerSelector,setCurrentTimerAction,resetCurrentTimerAction}from'@admin-layout/timetracker-core';import WeeklyRecord from'./WeeklyRecord/index.js';import {msToHMS}from'../../../utils/timeConverter.js';const TrayTimerHandler = (props) => {
    const dispatch = useDispatch();
    const currentTimer = useSelector(currentTimerSelector);
    const [timeDuration, setTimeDuration] = useState(0);
    const onChangeTrack = () => {
        console.log('----START TIMER', currentTimer);
        if (currentTimer.startTime === null) {
            dispatch(setCurrentTimerAction({
                endTime: null,
                startTime: new Date,
                projectId: 'testProject',
                taskId: 'testTask',
                id: '#1'
            }));
        }
        else {
            console.log('--DISPATCH');
            dispatch(resetCurrentTimerAction());
        }
    };
    const calculateTimeDuration = () => {
        const now = new Date().getTime();
        const statedTime = new Date(currentTimer.startTime).getTime();
        setTimeDuration((currentTimer.startTime === null) ? 0 : now - statedTime);
    };
    setTimeout(() => {
        calculateTimeDuration();
    }, 1000);
    const timeLog = {
        id: '#1',
        weeklyLogs: [
            {
                dates: 'Apr 26 - May 02',
                duration: 10 * 3600 + 47 * 60 + 23,
                days: [
                    {
                        dates: "Mon 26 Apr'21",
                        duration: 10 * 3600 + 47 * 60 + 23,
                        title: 'Title',
                        price: 1000,
                        description: 'description apr 26'
                    }
                ]
            },
            {
                dates: 'May 03 - May 09',
                duration: 6 * 3600 + 47 * 60 + 23,
                days: [
                    {
                        dates: `Mon 04 May'21`,
                        duration: 4 * 3600 + 30 * 60 + 48,
                        title: 'title May 04',
                        price: 1000,
                        description: 'description May 04'
                    },
                    {
                        dates: `Wed 06 May'21`,
                        duration: 1 * 3600 + 30 * 60 + 48,
                        title: 'title May 06',
                        price: 1000,
                        description: 'descriotion May 04'
                    }
                ]
            }
        ]
    };
    return (React__default.createElement("div", null,
        React__default.createElement(HeaderTimerHandler, { onTrack: onChangeTrack, trackStarted: currentTimer.startTime, timeDuration: msToHMS(timeDuration) }),
        React__default.createElement("div", { className: "time-logs" }, timeLog.weeklyLogs.map((log) => React__default.createElement(WeeklyRecord, { log: log })))));
};export default TrayTimerHandler;//# sourceMappingURL=index.js.map
