import React__default,{useState}from'react';import classNames from'classnames';import {useFela}from'react-fela';import moment from'moment';import {PageContainer}from'@admin-layout/components';import PageHeader from'../../components/PageHeader/index.js';import {TimerSearchComponent}from'../../components/TimerSearchComponent/index.js';import {TimeTracker}from'../../components/TimeTracker/index.js';import {TutorialComponent}from'../../components/TutorialComponent/index.js';import {setCurrentTimerAction}from'@admin-layout/timetracker-core';import {useSelector,useDispatch}from'react-redux';import {useCreatePermissions}from'../../hooks/index.js';import {TRACKER_MODE}from'../../constants/enums.js';import {TimerList}from'./TimerList.js';import*as _ from'lodash';const TimerActivity = (props) => {
    const { css } = useFela();
    const { timeRecords, isMobile, timer, isRecording, isPause, projects, tasks, weekStart, range, currentTimeRecord, createTimeRecord, removeTimeRecord, updateTimeRecord, setCurrentTimeRecord, removePlayingTimeRecord, setRange, createTask, } = props;
    const [mode, setMode] = useState(TRACKER_MODE.TRACK);
    const userId = useSelector((state) => state.user.auth0UserId);
    const { self: createPermit } = useCreatePermissions();
    const dispatch = useDispatch();
    const startTimer = (description) => {
        if (currentTimeRecord.startTime === null) {
            const newTimeRecord = Object.assign(Object.assign({}, currentTimeRecord), { userId, startTime: moment(), endTime: null, description });
            createTimeRecord(newTimeRecord);
        }
        else {
            dispatch(setCurrentTimerAction(Object.assign(Object.assign({}, currentTimeRecord), { isPause: false })));
        }
    };
    // save current time record to database
    const saveCurrentTimeRecord = () => {
        const endTime = moment();
        const startTime = moment(currentTimeRecord.startTime);
        const newTimeRecord = {
            userId: userId,
            startTime: startTime,
            endTime: endTime,
            description: currentTimeRecord.description,
            projectId: currentTimeRecord.projectId,
            isBillable: currentTimeRecord.isBillable,
        };
        if (currentTimeRecord.id === undefined || currentTimeRecord.id === '')
            createTimeRecord(newTimeRecord);
        else
            updateTimeRecord(currentTimeRecord.id, newTimeRecord);
    };
    const stopTimer = () => {
        saveCurrentTimeRecord();
    };
    const onPauseTimer = () => {
        dispatch(setCurrentTimerAction(Object.assign(Object.assign({}, currentTimeRecord), { isPause: true })));
    };
    const updatePlayingTimeRecord = (timeRecord) => {
        setCurrentTimeRecord(timeRecord);
        if (currentTimeRecord.id !== undefined && currentTimeRecord.id !== '') {
            updateTimeRecord(timeRecord.id, Object.assign({}, _.omit(timeRecord, ['__typename', 'id'])));
        }
    };
    return (React__default.createElement("div", { className: css(styleSheet.root) },
        React__default.createElement(PageContainer, null,
            React__default.createElement(PageHeader, { disabledTitle: isMobile },
                React__default.createElement(TimerSearchComponent, Object.assign({ weekStart: weekStart }, range, { setRange: setRange }))),
            React__default.createElement(TutorialComponent, null,
                React__default.createElement("div", { className: classNames('main-page', {
                        'main-page--mobile': isMobile,
                    }) },
                    React__default.createElement("div", { className: "task-container" },
                        React__default.createElement(TimeTracker, { projects: projects, tasks: tasks, isRecording: isRecording, isPause: isPause, timer: timer, mode: mode, weekStart: weekStart, handleStart: startTimer, handleStop: stopTimer, handlePause: onPauseTimer, setMode: setMode, disable: createPermit !== "Allow" /* Allow */, createTask: createTask, createTimeRecord: createTimeRecord, currentTimeRecord: currentTimeRecord, setCurrentTimeRecord: setCurrentTimeRecord, updatePlayingTimeRecord: updatePlayingTimeRecord, removePlayingTimeRecord: removePlayingTimeRecord })),
                    React__default.createElement(TimerList, { timeRecords: timeRecords, projects: projects, createTimeRecord: createTimeRecord, removeTimeRecord: removeTimeRecord, updateTimeRecord: updateTimeRecord, createTask: createTask, stopTimer: startTimer, isRecording: isRecording, setMode: setMode, weekStart: weekStart }))))));
};
const styleSheet = {
    root: () => ({
        position: 'relative',
        width: '100%',
        '& .main-page': {
            display: 'flex',
            flexDirection: 'column',
            '@media(max-width: 758px)': {
                padding: '0px',
                marginLeft: '-20px',
                marginRight: '-20px',
            },
            fontSize: '1.2rem',
            lineHeight: '1.6rem',
            overflow: 'hidden',
            height: '140vh',
        },
        '& .main-page__list': {
            flexGrow: '1',
            height: '100%',
            backgroundColor: '#f0f2f5',
        },
        '& .mainPage--mobile': {
            padding: '0 1rem 0 1rem',
        },
    }),
};export default TimerActivity;export{styleSheet};//# sourceMappingURL=TimerActivity.js.map
